program pokus;

uses	crt,opendlg,readkeyw,exitdlg;

{***************************************************************************}
{*                                                                         *}
{*                     ZX SCREEN CONVERTOR - CYGNUS                        *}
{*                                                                         *}
{* Program na konverzi BMP do formtu ZX Spectra (oboj monochrom 256x192) *}
{* 30.4.2000                                                               *}
{* 1.10.2000  - pekompilovno a mrn upraveno, fuknce stejn             *}
{***************************************************************************}

{GLOBAL}
type	Tmonozx=array [0..6143] of byte;
	Tmonobmp=array [0..6205] of byte;

{==============================================================================}
procedure convert (var s:Tmonobmp;var t:Tmonozx);
var	line,bmpindex,zxi1,zxi2,zxi3,i:longint;
begin
  bmpindex:=6205;
  zxi1:=0;
  zxi2:=0;
  zxi3:=0;
  for line:=1 to 192 do
  begin
    for i:=31 downto 0 do	{ jeden mikrodek pozptku }
    begin
      t[zxi1+zxi2+zxi3+i]:=not(s[bmpindex]);
      dec (bmpindex);
    end;
{jakoby DOWNHL}
    zxi1:=zxi1+256;	{ posunut o 1 mikrodek dol }
    if zxi1=2048 then 	{ posunut o 1 dek }
    begin
      zxi1:=0;
      zxi2:=zxi2+32;
      if zxi2=256 then	{ posunut o jednu 1/3 dol }
      begin
        zxi2:=0;
        zxi3:=zxi3+2048;
      end;
    end;
  end;
end;
{==============================================================================}
var	source:file of Tmonobmp;
	target:file of Tmonozx;
	path,name,ext:string;
	bmp:Tmonobmp;
        zxscreen:Tmonozx;
        KonecProgramu:boolean;
        n:word;
	lines:word;
begin
  If LastMode=co80 then lines:=25 else lines:=50;
  Window (1,1,80,lines);
  TextColor (7);
  TextBackGround (0);
  ClrScr;
  CursorOff;
  KonecProgramu:=false;
  OpenDialogLines:=(lines-9);

  repeat
    DestroyFileList;
    CreateFileList ('*.bmp');
    OpenFileDialog ('*.bmp',path,name,ext); { vbr soubor }
    if PocetZvolenychSouboru>0 then
    begin
      n:=PocetZvolenychSouboru;
      While n>0 do
      begin
        Window (1,lines-4,80,lines); ClrScr;
        Writeln ('Soubor : ',name,ext);

        assign (source,path+name+ext);    reset (source);
        assign (target,path+name+'.scr'); rewrite (target);

        if FileSize (source)=1 then // dlka je 1 prvek typu Tmonobmp
        begin // soubor m sprvnou dlku
          read (source,bmp);
          Writeln ('Pevd se.');
          Convert (bmp,zxscreen);
          Writeln ('Ukld se : ',name,'.scr');
          Write (target,zxscreen);
          Writeln ('spn dokoneno.');
        end else begin // soubor nem sprvnou dlku
          TextColor (12);
          Writeln ('POZOR ! Zdrojov soubor nen monochromatick obrzek 256x192 bod.');
          TextColor (7);
          //  Writeln (FileSize (source));
          Writeln ('Stisknte libovolnou klvesu.');
          repeat until keypressed; readkey;
        end;
        close (target);
        close (source);
        // konverze dokonena, pokrauj ppadnm dalm souborem
        dec (n);
        NextSelectedFile (path,name,ext);
      end;
      Window (1,1,80,lines);
    end else begin  // PocetZvolenychSouboru=0 => stisknuta klv. escape
      KonecProgramu:=ExitDialog (' ZX Screen Convertor ','Opravdu chcete ukonit program ?');
      Window (1,1,80,lines);
    end;
  until KonecProgramu;
  { KONEC }
  // Informan text na zvr programu
  TextColor (7); TextBackGround (0); ClrScr;
  TextColor (14);
  Writeln ('Program pro konverzi soubor BMP (256x192 1bit) na soubory typu SCR');
  Writeln ('(ZX Spectrum monochrome 6144 byt) napsal CYGNUS v dubnu roku 2000.');
  Writeln;
  Writeln ('Pepracovno a vylepeno 1.10.2000');
  Writeln;
  Writeln;
  TextColor (12); Writeln ('Navtivte tyto adresy :');
  TextColor (11);
  Writeln ('http://pavel_cejka.mujweb.cz - bude mon zruena kvli podtrtku');
  Writeln ('http://www.kapsa.club.cz/pavelcejka');
  TextColor (12); Writeln ('Mj email :');
  TextColor (11); Writeln ('pavel.cejka@kapsa.club.cz');
  TextColor (7);
end.
{==============================================================================}